/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code is mozilla.org code.
 *
 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation.  Portions created by Netscape are
 * Copyright (C) 1998 Netscape Communications Corporation. All
 * Rights Reserved.
 *
 * Contributor(s):
 *   Peter Hartshorn <peter@igelaus.com.au>
 *   B.J. Rossiter <bj@igelaus.com.au>
 */

#include "nsScreenNanoX.h"

#include <nano-X.h>

nsScreenNanoX :: nsScreenNanoX (  )
{
  NS_INIT_REFCNT();
  GrGetScreenInfo(&si);
}


nsScreenNanoX :: ~nsScreenNanoX()
{
  // nothing to see here.
}


// addref, release, QI
NS_IMPL_ISUPPORTS(nsScreenNanoX, NS_GET_IID(nsIScreen))


NS_IMETHODIMP
nsScreenNanoX :: GetRect(PRInt32 *outLeft, PRInt32 *outTop, PRInt32 *outWidth, PRInt32 *outHeight)
{
  *outTop = 0;
  *outLeft = 0;
  *outWidth = si.cols;
  *outHeight = si.rows;

  return NS_OK;
  
} // GetRect


NS_IMETHODIMP
nsScreenNanoX :: GetAvailRect(PRInt32 *outLeft, PRInt32 *outTop, PRInt32 *outWidth, PRInt32 *outHeight)
{
  *outTop = 0;
  *outLeft = 0;
  *outWidth = si.cols;
  *outHeight = si.rows;

  return NS_OK;
  
} // GetAvailRect


NS_IMETHODIMP 
nsScreenNanoX :: GetPixelDepth(PRInt32 *aPixelDepth)
{
  *aPixelDepth = si.bpp;

  return NS_OK;

} // GetPixelDepth


NS_IMETHODIMP 
nsScreenNanoX :: GetColorDepth(PRInt32 *aColorDepth)
{
  return GetPixelDepth ( aColorDepth );

} // GetColorDepth


