/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code is mozilla.org code.
 *
 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation.  Portions created by Netscape are
 * Copyright (C) 1998 Netscape Communications Corporation. All
 * Rights Reserved.
 *
 * Contributor(s):
 *   Peter Hartshorn <peter@igelaus.com.au>
 *   B.J. Rossiter <bj@igelaus.com.au>
 */

#include "nsNanoXWindowService.h"

nsNanoXWindowService::nsNanoXWindowService()
{
  NS_INIT_REFCNT();
}

nsNanoXWindowService::~nsNanoXWindowService()
{
}

NS_IMPL_ADDREF(nsNanoXWindowService)
NS_IMPL_RELEASE(nsNanoXWindowService)
NS_IMPL_QUERY_INTERFACE(nsNanoXWindowService, NS_GET_IID(nsINanoXWindowService))

nsNanoXWindowCallback         nsNanoXWindowService::gsWindowCreateCallback = nsnull;
nsNanoXWindowCallback         nsNanoXWindowService::gsWindowDestroyCallback = nsnull;
nsNanoXEventDispatcher        nsNanoXWindowService::gsEventDispatcher = nsnull;
nsNanoXTimeToNextTimeoutFunc  nsNanoXWindowService::gsTimeToNextTimeoutFunc = nsnull;
nsNanoXProcessTimeoutsProc    nsNanoXWindowService::gsProcessTimeoutsProc = nsnull;

NS_IMETHODIMP
nsNanoXWindowService::SetWindowCreateCallback(nsNanoXWindowCallback aCallback)
{
  NS_ASSERTION(nsnull != aCallback,"null in ptr.");

  gsWindowCreateCallback = aCallback;

  return NS_OK;
}
//////////////////////////////////////////////////////////////////////////
NS_IMETHODIMP
nsNanoXWindowService::SetWindowDestroyCallback(nsNanoXWindowCallback aCallback)
{
  NS_ASSERTION(nsnull != aCallback,"null in ptr.");

  gsWindowDestroyCallback = aCallback;

  return NS_OK;
}
//////////////////////////////////////////////////////////////////////////
NS_IMETHODIMP
nsNanoXWindowService::SetEventDispatcher(nsNanoXEventDispatcher aDispatcher)
{
  NS_ASSERTION(nsnull != aDispatcher,"null in ptr.");

  gsEventDispatcher = aDispatcher;

  return NS_OK;
}
//////////////////////////////////////////////////////////////////////////
NS_IMETHODIMP
nsNanoXWindowService::GetWindowCreateCallback(nsNanoXWindowCallback * aCallbackOut)
{
  NS_ASSERTION(nsnull != aCallbackOut,"null out ptr.");

  *aCallbackOut = gsWindowCreateCallback;

  return NS_OK;
}
//////////////////////////////////////////////////////////////////////////
NS_IMETHODIMP
nsNanoXWindowService::GetWindowDestroyCallback(nsNanoXWindowCallback * aCallbackOut)
{
  NS_ASSERTION(nsnull != aCallbackOut,"null out ptr.");

  *aCallbackOut = gsWindowDestroyCallback;

  return NS_OK;
}
//////////////////////////////////////////////////////////////////////////
NS_IMETHODIMP
nsNanoXWindowService::GetEventDispatcher(nsNanoXEventDispatcher * aDispatcherOut)
{
  NS_ASSERTION(nsnull != aDispatcherOut,"null out ptr.");

  *aDispatcherOut = gsEventDispatcher;

  return NS_OK;
}
//////////////////////////////////////////////////////////////////////////
NS_IMETHODIMP
nsNanoXWindowService::SetTimeToNextTimeoutFunc(nsNanoXTimeToNextTimeoutFunc aFunc)
{
  NS_ASSERTION(nsnull != aFunc,"null in ptr.");

  gsTimeToNextTimeoutFunc = aFunc;

  return NS_OK;
}
//////////////////////////////////////////////////////////////////////////
NS_IMETHODIMP
nsNanoXWindowService::GetTimeToNextTimeoutFunc(nsNanoXTimeToNextTimeoutFunc * aFuncOut)
{
  NS_ASSERTION(nsnull != aFuncOut,"null out ptr.");

  *aFuncOut = gsTimeToNextTimeoutFunc;

  return NS_OK;
}
//////////////////////////////////////////////////////////////////////////
NS_IMETHODIMP
nsNanoXWindowService::SetProcessTimeoutsProc(nsNanoXProcessTimeoutsProc aProc)
{
  NS_ASSERTION(nsnull != aProc,"null in ptr.");

  gsProcessTimeoutsProc = aProc;

  return NS_OK;
}
//////////////////////////////////////////////////////////////////////////
NS_IMETHODIMP
nsNanoXWindowService::GetProcessTimeoutsProc(nsNanoXProcessTimeoutsProc * aProcOut)
{
  NS_ASSERTION(nsnull != aProcOut,"null out ptr.");

  *aProcOut = gsProcessTimeoutsProc;

  return NS_OK;
}
//////////////////////////////////////////////////////////////////////////
